<?php
/*
Plugin Name: MultiCity Permalink
Plugin URI: //templatic.com/
Description: Select the city to set in permalink.
Version: 1.0.2
Author: Templatic
Author URI: //templatic.com/
*/

add_action( 'admin_init','city_section_actions' );

$locale = get_locale();
load_textdomain( 'templatic-admin', plugin_dir_path( __FILE__ ) . 'languages/' . $locale . '.mo' );


function city_section_actions() {
	add_action( 'admin_head','citypermalink_script' );
	add_action( 'tevolution_multicity','citypermalink_fields' );

	/* code for city permalink BOF */
	add_action( 'wp_ajax_nopriv_fill_the_permalink','fill_the_permalink' );
	add_action( 'wp_ajax_fill_the_permalink','fill_the_permalink' );
}
function fill_the_permalink() {
	global $wpdb,$country_table,$zones_table,$multicity_table;
	$cityinfo = $_REQUEST['cities'];
	$cityinfo = explode( ',',$cityinfo );
	if ( $cityinfo ) :
		for ( $c = 0; $c < count( $cityinfo ); $c++ ) :
			$cityinformation = $wpdb->get_row( $wpdb->prepare( "SELECT * FROM $multicity_table where city_id =%d",$cityinfo[ $c ] ) );
			$city_ontion .= '<option value="' . $cityinfo[ $c ] . '" >' . $cityinformation->cityname . '</option>';
		endfor;
	else :
		$city_ontion = '<option value="">' . __( 'City not available','templatic-admin' ) . '</option>';
	endif;
	echo $city_ontion;
	exit;
}
/* code for city permalink EOF */


/*
Name: citypermalink_fields
Desc : Return the city od field to set the permalink
*/
function citypermalink_fields() {
		global $wpdb,$post,$country_table,$zones_table,$multicity_table;

	if ( get_post_meta( $post->ID,'city_permalink',true ) != '' ) {
		$city = get_post_meta( $post->ID,'city_permalink',true );

		$dsel = '';
		$style = 'style=display:block';
	} else {

		$dsel = 'selected=selected';
		$style = 'style=display:none';
	}

		$cityname = $wpdb->get_row( $wpdb->prepare( "SELECT * FROM $multicity_table where city_id =%d",$city ) );
		echo "<div id='permalink_container' $style>";
		_e( 'Select your primary city to generate URL for this listing','templatic-admin' );

		$country = get_post_meta( $post->ID,'country_id',true );
		$post_city_id = get_post_meta( $post->ID,'post_city_id',true );
		$cities = $wpdb->get_results( $wpdb->prepare( "SELECT * FROM $multicity_table where country_id =%d",$country ) );
	

		?>&nbsp;
			
			<select type="text" name="city_permalink" id="city_permalink">
				<option value="" <?php echo $dsel; ?>><?php _e( 'City Permalink Slug','templatic-admin' ); ?></option>
				<?php if ( $city != '' ) {
					for ( $c = 0; $c <= count( $cities ); $c++ ) {
						if ( $cities[ $c ]->cityname != '' ) {
							if ( $city == $cities[ $c ]->city_id ) { $selected = 'selected=selected';
							} else {  $selected = ''; }
							?>
							<option value="<?php echo $cities[ $c ]->city_id; ?>" <?php echo $selected; ?>><?php echo $cities[ $c ]->cityname; ?></option>
						<?php }
					}
} ?>
			</select>
<?php	echo '</div>';
}
/*
Name: citypermalink_script
Desc : Return the permalink of the city
*/
function citypermalink_script() {
?>
	<script type="text/javascript">
	var ajaxUrl = "<?php echo esc_js( get_bloginfo( 'wpurl' ) . '/wp-admin/admin-ajax.php' ); ?>";
	</script>
	<?php
	wp_enqueue_script( 'permalink_script',plugins_url( 'Directory-CityPermalink/permalink.js' ),array( 'jquery' ),'',false );
}
add_action( 'save_post', 'dir_save_permalink' ); // action to save permalink

function dir_save_permalink() {
	global $post,$wpdb;
	if ( isset( $_REQUEST['city_permalink'] ) && $_REQUEST['city_permalink'] != '' ) {
		update_post_meta( $post->ID,'city_permalink',wp_kses_post( $_REQUEST['city_permalink'] ) );
	}
}

/*
 * Function Name: templatic_create_permalinks
 * Return : post_city_id is available , add city name slug in permalink
 */
add_filter( 'post_type_link', 'templatic_city_permalinks', 0, 3 );
function templatic_city_permalinks( $permalink, $post, $leavename ) {
	global $current_cityinfo;
	$no_data = 'no-data';
	$post_id = $post->ID;
	$pcity_id = get_post_meta( $post->ID,'city_permalink',true );
	if ( ! $pcity_id ) {
		$pcity_id = get_post_meta( $post->ID,'post_city_id',true );
	}
	if ( ($post->post_type != '' && $pcity_id != '') && ( empty( $permalink ) || in_array( $post->post_status, array( 'draft', 'pending', 'auto-draft' ) )) ) {
		return $permalink;
	}

	global $wpdb,$city_info;
	$multicity_db_table_name = $wpdb->prefix . 'multicity'; // DATABASE TABLE  MULTY CITY
	$pcity_id = $pcity_id;
	if ( get_post_meta( $post->ID,'city_permalink',true ) == '' ) {
		$pcity_id = get_post_meta( $post->ID,'post_city_id',true );
		if ( strstr( $pcity_id,',' ) ) {
			$pcity_id_ = explode( ',',$pcity_id );
			$pcity_id = $pcity_id_[0];
		}
	}
	if ( ! is_admin() && ! empty( $pcity_id_ ) && is_array( $pcity_id_ ) && in_array( $current_cityinfo['city_id'],$pcity_id_ ) ) {
		$pcity_id = $current_cityinfo['city_id'];
	}
	if ( $pcity_id != '' ) {
		if ( is_admin() || (defined( 'DOING_AJAX' ) && DOING_AJAX) || is_singular() || is_search() || (isset( $_REQUEST['page'] ) && $_REQUEST['page'] == 'success') || strpos( $_SERVER['REQUEST_URI'],'sitemap' ) !== false ) {
			$city = strtolower( $wpdb->get_var( "SELECT city_slug FROM $multicity_db_table_name WHERE city_id =\"$pcity_id\"" ) );
		} else {
			$city = (get_post_meta( $post->ID,'city_permalink',true ) == '' && ! is_author())? $current_cityinfo['city_slug']:strtolower( $wpdb->get_var( "SELECT city_slug FROM $multicity_db_table_name WHERE city_id =\"$pcity_id\"" ) );
		}
	} else {
		$city = 'na';
	}

	$city_slug = get_option( 'location_multicity_slug' );
	$multi_city = ($city_slug)? $city_slug : 'city';

	$tevolution_taxonomies_data = get_option( 'tevolution_taxonomies_rules_data' );
	if ( @$tevolution_taxonomies_data['tevolution_location_city_remove'] == 1 ) {
		$permalink = str_replace( '%city%', $city, $permalink );
		$permalink = str_replace( '/' . $multi_city . '/', '/', $permalink );
	} else {
		$permalink = str_replace( '%city%', $city, $permalink );
	}

	return $permalink;
}

remove_action( 'wp_head','location_multicity_get_posts',0 );
add_action( 'wp_head','location_city_redirect',0 );
/*
Name:location_city_redirect
Description: to redirect on home page if user change the city on detail page permalink , and city not match with selected permalink
*/
function location_city_redirect( $query ) {
	global $wp_query, $post,$current_cityinfo,$wpdb;
	$multicity_table = $wpdb->prefix . 'multicity';
	$city_slug = get_option( 'location_multicity_slug' );
	$multi_city = ($city_slug)? $city_slug : 'city';
	if ( ! is_admin() && is_single() && get_post_type() != '' ) {
		$location_post_type = implode( ',',get_option( 'location_post_type' ) );
		if ( strpos( $location_post_type,',' . get_post_type() ) !== false ) {

			if ( get_post_meta( $post->ID,'city_permalink',true ) != '' ) {
				$city_permalink = get_post_meta( $post->ID,'city_permalink',true );
			}

			if ( get_post_meta( $post->ID,'post_city_id',true ) ) {
				$multi_citry_id = explode( ',',get_post_meta( $post->ID,'post_city_id',true ) );
			}

			$city_var = get_query_var( $multi_city );

			if ( $city_var ) {
				$current_city = $city_var;
			}

			if ( $city_permalink && ! in_array( $city_permalink,$multi_citry_id ) ) {
				wp_redirect( site_url() );
				exit;
			}
		}
	}
}
?>
